//
//  SMTToasterAdViewController.m
//  iSomaDemo
//
//  Created by Aman Shaikh on 20/05/14.
//  Copyright (c) 2014 Smaato Inc. All rights reserved.
//

#import "SMTToasterAdViewController.h"
#import <iSoma/iSoma.h>
#import "SMTAppSettings.h"

@interface SMTToasterAdViewController ()<SOMAAdViewDelegate>
@end

@implementation SMTToasterAdViewController
- (void)viewDidLoad{
    [super viewDidLoad];
	
	[self createAd];
}

#pragma mark -
#pragma mark - SOMAAdViewDelegate
#pragma mark -

- (void)somaAdViewWillLoadAd:(SOMAAdView*)adview{
	NSLog(@"Ad View Will Load");
}

- (void)somaAdViewDidLoadAd:(SOMAAdView*)adview{
	NSLog(@"Ad View Loaded");
}

- (void)createAd{
	
	CGRect adFrame = (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) ?
	CGRectMake(0, 0, 728, 90) : CGRectMake(0, 0, 320, 50);
	
	SOMAAdView *adView =
	[[SOMAAdView alloc] initWithFrame:adFrame];
	adView.adSettings.publisherId = 1100004740;
	adView.adSettings.adSpaceId = 130019751;
	
	adView.adSettings.userProfile.age = 30;
	adView.shouldAppearAutomatically = YES;
	
	// Send location
	double latitude = 90;
	double longitude = 100;
	
	adView.adSettings.latitude = latitude;
	adView.adSettings.longitude = longitude;
	adView.adSettings.userProfile.ethnicity = SOMAUserEthnicityMiddleEastern;
	adView.adSettings.userProfile.maritalStatus = SOMAUserMaritalStatusSingle;
	
	// Remaining adView settings
	adView.adSettings.userProfile.gender = SOMAUserGenderFemale;
	adView.adSettings.userProfile.interestedIn = SOMAUserGenderInterestFemale;
	adView.adSettings.type = SOMAAdTypeImage;
	
	
	adView.adSettings.autoReloadEnabled = YES;
	
	[adView load];
	
	[self.view addSubview:adView];
	
}

- (void)somaAdView:(SOMAAdView*)adview didFailToReceiveAdWithError:(NSError *)error{
	BOOL reloadEnabled = adview.adSettings.isAutoReloadEnabled;
	int reloadInterval = adview.adSettings.autoReloadInterval;
	NSString* reloadTimeMessage = @"";
	if (reloadEnabled) {
		reloadTimeMessage = [NSString stringWithFormat:@", in %d Seconds", reloadInterval];
	}
	NSLog(@"Ad View Failed to load: reloading:%@ %@", reloadEnabled == YES?@"YES":@"NO", reloadTimeMessage);
}

- (BOOL)somaAdViewShouldEnterFullscreen:(SOMAAdView*)adview{
	NSLog(@"Ad Clicked, will go fullscreen");
	return YES;
}

- (void)somaAdViewDidExitFullscreen:(SOMAAdView*)adview{
	NSLog(@"Exited full screen");
}

- (void)somaAdViewWillHide:(SOMAAdView*)adview{
	NSLog(@"Ad view will hide");
}



@end
