//
//  SMTiAdViewController.m
//  iSomaDemo
//
//  Created by Aman Shaikh on 20/05/14.
//  Copyright (c) 2014 Smaato Inc. All rights reserved.
//

#import "SMTiAdViewController.h"
#import <iAd/iAd.h>
#import "SMTAppSettings.h"

@implementation SMTiAdViewController

- (void)viewDidLoad{
    [super viewDidLoad];
	self.somaAdView.shouldAppearAutomatically = NO;
}

#pragma mark -
#pragma mark - SOMAAdViewDeelgate
#pragma mark -

- (void)somaAdViewDidLoadAd:(SOMAAdView*)adview{
	NSLog(@"Ad View Loaded");
	if (self.iAdbannerView.isHidden) {
		[self.somaAdView show];
	} else {
		[self.somaAdView pause];
	}
}

- (void)somaAdView:(SOMAAdView*)adview didFailToReceiveAdWithError:(NSError *)error{
	BOOL reloadEnabled = adview.adSettings.isAutoReloadEnabled;
	int reloadInterval = adview.adSettings.autoReloadInterval;
	NSString* reloadTimeMessage = @"";
	if (reloadEnabled) {
		reloadTimeMessage = [NSString stringWithFormat:@", in %d Seconds", reloadInterval];
	}
	NSLog(@"Ad View Failed to load: reloading:%@ %@", reloadEnabled == YES?@"YES":@"NO", reloadTimeMessage);
	
	[self.somaAdView hide];
	if (self.iAdbannerView.isBannerLoaded) {
		self.iAdbannerView.hidden = NO;
	}
}

#pragma mark -
#pragma mark - iAD ADBannerViewDelegatre
#pragma mark -

- (void)bannerViewWillLoadAd:(ADBannerView *)banner{
	NSLog(@"iAd loaded!");
	banner.hidden = NO;
	[self.somaAdView hide];
	[self.somaAdView pause];
}

- (void)bannerView:(ADBannerView *)banner didFailToReceiveAdWithError:(NSError *)error {
	NSLog(@"iAd failed to load: %@", [error localizedDescription]);
	banner.hidden =YES;
	if (self.somaAdView.isLoaded) {
		[self.somaAdView show];
		[self.somaAdView resume];
	} else {
		[self.somaAdView load];
	}
}

@end
